from __future__ import annotations
import datetime
from dataclasses import dataclass, field
from kiota_abstractions.serialization import Parsable, ParseNode, SerializationWriter
from typing import Any, Callable, Dict, List, Optional, TYPE_CHECKING, Union

if TYPE_CHECKING:
    from .entity import Entity

from .entity import Entity

@dataclass
class AppVulnerabilityMobileApp(Entity):
    """
    An app vulnerability mobile app.
    """
    # The created date.
    created_date_time: Optional[datetime.datetime] = None
    # The device name.
    display_name: Optional[str] = None
    # The last modified date.
    last_modified_date_time: Optional[datetime.datetime] = None
    # The Intune mobile app ID.
    mobile_app_id: Optional[str] = None
    # The app type.
    mobile_app_type: Optional[str] = None
    # The OdataType property
    odata_type: Optional[str] = None
    # The app version.
    version: Optional[str] = None
    
    @staticmethod
    def create_from_discriminator_value(parse_node: ParseNode) -> AppVulnerabilityMobileApp:
        """
        Creates a new instance of the appropriate class based on discriminator value
        param parse_node: The parse node to use to read the discriminator value and create the object
        Returns: AppVulnerabilityMobileApp
        """
        if parse_node is None:
            raise TypeError("parse_node cannot be null.")
        return AppVulnerabilityMobileApp()
    
    def get_field_deserializers(self,) -> Dict[str, Callable[[ParseNode], None]]:
        """
        The deserialization information for the current model
        Returns: Dict[str, Callable[[ParseNode], None]]
        """
        from .entity import Entity

        from .entity import Entity

        fields: Dict[str, Callable[[Any], None]] = {
            "createdDateTime": lambda n : setattr(self, 'created_date_time', n.get_datetime_value()),
            "displayName": lambda n : setattr(self, 'display_name', n.get_str_value()),
            "lastModifiedDateTime": lambda n : setattr(self, 'last_modified_date_time', n.get_datetime_value()),
            "mobileAppId": lambda n : setattr(self, 'mobile_app_id', n.get_str_value()),
            "mobileAppType": lambda n : setattr(self, 'mobile_app_type', n.get_str_value()),
            "version": lambda n : setattr(self, 'version', n.get_str_value()),
        }
        super_fields = super().get_field_deserializers()
        fields.update(super_fields)
        return fields
    
    def serialize(self,writer: SerializationWriter) -> None:
        """
        Serializes information the current object
        param writer: Serialization writer to use to serialize this model
        Returns: None
        """
        if writer is None:
            raise TypeError("writer cannot be null.")
        super().serialize(writer)
        writer.write_datetime_value("createdDateTime", self.created_date_time)
        writer.write_str_value("displayName", self.display_name)
        writer.write_datetime_value("lastModifiedDateTime", self.last_modified_date_time)
        writer.write_str_value("mobileAppId", self.mobile_app_id)
        writer.write_str_value("mobileAppType", self.mobile_app_type)
        writer.write_str_value("version", self.version)
    

